//======================================================
//  MBot v0.93
//
//   
//======================================================

#include maps\mp\mbot\_utils;

// Cepe7a -->
mbotInit()
{
	//    
	level.velsqr = [];
	addvelsqr(12, 0.17);
	addvelsqr(25, 0.25);
	addvelsqr(37, 0.31);
	addvelsqr(50, 0.36);
	addvelsqr(75, 0.44);
	addvelsqr(100, 0.51);
	addvelsqr(125, 0.56);
	addvelsqr(150, 0.62);
	addvelsqr(175, 0.67);
	addvelsqr(200, 0.71);
	addvelsqr(250, 0.8);
	addvelsqr(300, 0.88);
	addvelsqr(350, 0.94);
	addvelsqr(400, 1.01);
	addvelsqr(450, 1.07);
	addvelsqr(500, 1.13);
	addvelsqr(600, 1.21);
	addvelsqr(650, 1.29);
	addvelsqr(700, 1.34);
	addvelsqr(750, 1.38);
	addvelsqr(800, 1.43);
	addvelsqr(850, 1.5);
	addvelsqr(900, 1.51);
	addvelsqr(1000, 1.6);
	
	level thread addingBots();
}

addvelsqr(h, sqr)
{
	i = level.velsqr.size;
	level.velsqr[i] = spawnstruct();
	level.velsqr[i].h = h;
	level.velsqr[i].sqr = sqr;
}

getvelsqr(h)
{
	//        
	
	hprev = level.velsqr[0].h;
	for (i=1; i<level.velsqr.size; i++)
	{
		hcur = level.velsqr[i].h;
		if (h > hcur)
		{
			hprev = hcur;
			continue;
		}
		hcur = hprev + ((hcur - hprev) / 2);
		if (h < hcur)
			sqr = level.velsqr[i-1].sqr;
		else
			sqr = level.velsqr[i].sqr;
		return sqr;
	}
	
	return level.velsqr[i-1].sqr;
}


addingBots()
{
	level.addingbots = [];
	
	while(1)
	{
		j = 0;
		while (j<level.addingbots.size)
		{
			if (isDefined(level.addingbots[j].team))
			{
				team = level.addingbots[j].team;
				weaponNo = level.addingbots[j].weaponNo;
				level.addingbots[j].team = undefined;
				
				bot = undefined;
				players = getentarray("player", "classname");
				for(i = 0; i < players.size; i++)
				{
					if(players[i].pers["team"] == "spectator" && isDefined(players[i].isbot))
					{
						bot = players[i];
						break;
					}
				}
				if(!isdefined(bot))
				{
					bot = addtestclient();
					//level notify("connecting", bot);
				}

				if(isdefined(bot))
				{
					bot.isbot = true;
		
					switch(team)
					{
						case "auto":	bot thread botJoin("autoassign", weaponNo);		break;
						case "axis":  	bot thread botJoin("axis", weaponNo); 	 	 	break;
						case "allies":	bot thread botJoin("allies", weaponNo);		 	break;
					}      
					bot waittill("bot_joined");
					if(isdefined(level.botstart))
					{
						bot thread [[level.botstart]]();
					}					
				}
				else
				{
					level.nomorebots = true;
					for (i=0; i<level.addingbots.size; i++)
						level.addingbots[i].team = undefined;
					iprintlnbold(&"MBOT_NOMORE");
					break;
				}
				
				wait 0.1;
			}
			j++;
		}
		wait 0.5;
	}
}


addBotToQueue(team, weaponNo)
{
	if (isDefined(level.nomorebots))
		return;
		
	for(i=0; i<level.addingbots.size; i++)
	{
		if (!isDefined(level.addingbots[i].team))
			break;
	}
	tmp = spawnstruct();
	tmp.team = team;
	tmp.weaponNo = weaponNo;
	level.addingbots[i] = tmp;
}


//--------------------------------------------------------------------------------------------------------------------------------------
// Level functions
//--------------------------------------------------------------------------------------------------------------------------------------
/*
--------------
 addBot
--------------
*/
addBot(team)
{
	param = [];
	param = strtok(team, " ");
	if (param.size > 0)
		team = param[0];
		
	if (param.size < 1 || (team != "auto" && team != "axis" && team != "allies"))
	{
		iprintln(&"MBOT_ADD_USAGE");
		return;
	}

	if (param.size == 1)
		addBotToQueue(team, "");
	else
	{
		for (i=1; i<param.size; i++)
			addBotToQueue(team, param[i]);
	}
}
// <-- Cepe7a

/*
--------------
 removeBot
--------------
*/
removeBot(team)
{
	players = getentarray("player", "classname");
  
  
	switch(team)
	{
		case "allies":
			for(i = 0; i < players.size; i++)
			{
				if (!isDefined(players[i].isbot))
					continue;
				if(players[i].pers["team"] == "allies")
				{
					//players[i] notify("killed_player"); // Cepe7a
					//level.bots_al--;
					players[i] thread botJoin("spectator", "");
					break;
				}
			}
		break;
		
		case "axis":
			for(i = 0; i < players.size; i++)
			{
				if (!isDefined(players[i].isbot))
					continue;
				if(players[i].pers["team"] == "axis")
				{
					//players[i] notify("killed_player"); // Cepe7a
					//level.bots_ax--;
					players[i] thread botJoin("spectator", "");
					break;
				}
			}
		break;
		
		case "all":
			for(i = 0; i < players.size; i++) 
			{
				if (!isDefined(players[i].isbot))
					continue;
				players[i] notify("killed_player"); // Cepe7a
				players[i] thread botJoin("spectator", "");
			}

			//level.bots_al = 0;
			//level.bots_ax = 0;
		break;
		
		default:
			for(i = 0; i < players.size; i++)
			{
				if(players[i].name == team)
				{
					if(!isdefined(players[i].isbot))
					{
						println(players[i].name + " is not a bot");
						continue;
					}

/*
					if(players[i].pers["team"] == "allies")
						level.bots_al--;
					else if(players[i].pers["team"] == "axis")
						level.bots_ax--;
*/

					players[i] notify("killed_player"); // Cepe7a
					players[i] thread botJoin("spectator", "");
					break;
				}
			}
		break;
	}
}

/*
--------------
 setSkill
--------------
*/
setSkill(num)
{
  if(num > 10)
    num = 10;
  else if(num < 0)
    num = 0;

  setCvar("skill", num);
    
  level.botskill = num;
  level.botwaittime = 0.55 - (level.botskill/20);
  iprintln(&"MBOT_SKILLSWITCH", level.botskill);
}

/*
--------------
 mapIsSupportBots
--------------
*/
mapIsSupportBots(map, type)
{
  f = openfile((map + "_" + type + ".wp"), "read");
  if(f != -1)
  {
    closefile(f);
    return true;
  }

  return false;
}

/*
--------------
 loadMap
--------------
*/
loadMap(map, type)
{
  if(isdefined(level.plr))
  {
    setCvar("sv_mapRotationCurrent", ("gametype " + type + " map " + map));
    level.plr closeMenu();
    level.plr closeInGameMenu();
	wait 0.1;
    level.plr openMenu("mbot_restart");
  }
}

/*
--------------
 buildNodeInfo
--------------
*/
buildNodeInfo(file)
{
	println("\nLoading bot waypoints from ", file, " ...");
	f = openfile(file, "read");
	if(f == -1)
	{
		println(file, ": ^1Error! file not found\n");
		return false;
	}

	freadln(f);
	s = fgetarg(f, 0);
	if(!isdefined(s) || s != "mbotwp")
	{	
		closefile(f);
		println(file, ": ^1Error! Unknown file format.\n");
		return false;
	}

	i = 0;
	while(freadln(f) != -1)
	{
		s = fgetarg(f, 0);
		t = strtok(s, " ,");

		level.wp[i] = spawnstruct();
		level.wp[i].origin = (strtoflt(t[0]), strtoflt(t[1]), strtoflt(t[2]));

		switch(t[3])
		{
			case "w":
				level.wp[i].type = "w";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);

				// Cepe7a -->
				if (t.size == 9)
				{
					k += 6;
					level.wp[i].angles = (strtoflt(t[k]), strtoflt(t[k+1]), 0.0);
				}
				// <-- Cepe7a
			break;
			
			case "g":
				level.wp[i].type = "g";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				k = 0;
				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);
          
				k += 6;
				level.wp[i].angles = (strtoflt(t[k]), strtoflt(t[k+1]), 0.0);

			break;
			
			case "f":
				level.wp[i].type = "f";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);
			break;
			
			case "c":
				level.wp[i].type = "c";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				k = 0;
				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);

				k += 6;
				level.wp[i].angles = (strtoflt(t[k]), strtoflt(t[k+1]), 0.0);
			break;
			
			case "j":
				level.wp[i].type = "j";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);
			break;
		
			case "m":
				level.wp[i].type = "m";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				k = 0;
				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);

				k += 6;
				level.wp[i].mode = int(t[k]);
			break;
			
			case "l":
				level.wp[i].type = "l";
				level.wp[i].next = [];
				level.wp[i].stance = int(t[4]);

				for(k = 0; k < int(t[5]); k++)
					level.wp[i].next[k] = int(t[6+k]);
			break;
			
			default:
				closefile(f);
				println(file + ": ^1Error! Waypoint #" + i + " has unknown type.\n");
				return false;
		}
		i++;
	}
	closefile(f);
  
	if(i == 0)
	{
		println(file + ": ^1Error! No data found.\n");
		return false;
	}
  
	for(k = 0; k < level.wp.size; k++)
	{
		if(level.wp[k].next.size == 0)
			println(file, (": ^3Warning! Waypoint #" + k + " have no next waypoints"));
     
		if((level.wp[k].type == "f" || level.wp[k].type == "j" || level.wp[k].type == "m" || level.wp[k].type == "l") && level.wp[k].next.size > 1)
			println(file, (": ^3Warning! Waypoint #" + k + " of type \"" + level.wp[k].type + "\" have more then one next waypoints"));
	}

	println("Loaded.\n");
	return true;
}

/*
--------------
 precache
--------------
*/
precache()
{
	// weapons
	switch(game["allies"])
	{
		case "american":
			precacheItem("PPS42_bot_st");
	precacheItem("mosin_nagant_bot_st");
	precacheItem("mosin_nagant_sniper_bot_st");
	precacheItem("SVT40_bot_st");
        precacheItem("ppsh_bot_st");
        precacheItem("sten_bot_st");
	precacheItem("enfield_bot_st");
        precacheItem("enfield_scope_bot_st");
	precacheItem("bren_bot_st");
        precacheItem("greasegun_bot_st");
	precacheItem("m1carbine_bot_st");
	precacheItem("m1garand_bot_st");
        precacheItem("springfield_bot_st");
	precacheItem("bar_bot_st");
        precacheItem("thompson_bot_st");
	precacheItem("mp40_bot_st");
        precacheItem("kar98k_bot_st");
        precacheItem("kar98k_sniper_bot_st");
	precacheItem("g43_bot_st");
        precacheItem("mp44_bot_st");
	precacheItem("shotgun_bot_st");
			precacheItem("frag_grenade_american_bot");
			precacheItem("smoke_grenade_american_bot");
		break;
      
		case "british":
			precacheItem("PPS42_bot_st");
	precacheItem("mosin_nagant_bot_st");
	precacheItem("mosin_nagant_sniper_bot_st");
	precacheItem("SVT40_bot_st");
        precacheItem("ppsh_bot_st");
        precacheItem("sten_bot_st");
	precacheItem("enfield_bot_st");
        precacheItem("enfield_scope_bot_st");
	precacheItem("bren_bot_st");
        precacheItem("greasegun_bot_st");
	precacheItem("m1carbine_bot_st");
	precacheItem("m1garand_bot_st");
        precacheItem("springfield_bot_st");
	precacheItem("bar_bot_st");
        precacheItem("thompson_bot_st");
	precacheItem("mp40_bot_st");
        precacheItem("kar98k_bot_st");
        precacheItem("kar98k_sniper_bot_st");
	precacheItem("g43_bot_st");
        precacheItem("mp44_bot_st");
	precacheItem("shotgun_bot_st");
			precacheItem("frag_grenade_british_bot");
			precacheItem("smoke_grenade_british_bot");
		break;
      
		case "russian":
			precacheItem("PPS42_bot_st");
	precacheItem("mosin_nagant_bot_st");
	precacheItem("mosin_nagant_sniper_bot_st");
	precacheItem("SVT40_bot_st");
        precacheItem("ppsh_bot_st");
        precacheItem("sten_bot_st");
	precacheItem("enfield_bot_st");
        precacheItem("enfield_scope_bot_st");
	precacheItem("bren_bot_st");
        precacheItem("greasegun_bot_st");
	precacheItem("m1carbine_bot_st");
	precacheItem("m1garand_bot_st");
        precacheItem("springfield_bot_st");
	precacheItem("bar_bot_st");
        precacheItem("thompson_bot_st");
	precacheItem("mp40_bot_st");
        precacheItem("kar98k_bot_st");
        precacheItem("kar98k_sniper_bot_st");
	precacheItem("g43_bot_st");
        precacheItem("mp44_bot_st");
	precacheItem("shotgun_bot_st");
			precacheItem("frag_grenade_russian_bot");
			precacheItem("smoke_grenade_russian_bot");
		break;
	}

	precacheItem("PPS42_bot_st");
	precacheItem("mosin_nagant_bot_st");
	precacheItem("mosin_nagant_sniper_bot_st");
	precacheItem("SVT40_bot_st");
        precacheItem("ppsh_bot_st");
        precacheItem("sten_bot_st");
	precacheItem("enfield_bot_st");
        precacheItem("enfield_scope_bot_st");
	precacheItem("bren_bot_st");
        precacheItem("greasegun_bot_st");
	precacheItem("m1carbine_bot_st");
	precacheItem("m1garand_bot_st");
        precacheItem("springfield_bot_st");
	precacheItem("bar_bot_st");
        precacheItem("thompson_bot_st");
	precacheItem("mp40_bot_st");
        precacheItem("kar98k_bot_st");
        precacheItem("kar98k_sniper_bot_st");
	precacheItem("g43_bot_st");
        precacheItem("mp44_bot_st");
	precacheItem("shotgun_bot_st");
	precacheItem("frag_grenade_german_bot");
	precacheItem("smoke_grenade_german_bot");
  
	precacheItem("mantle_up_bot");
	precacheItem("mantle_over_bot");
	precacheItem("climb_up_bot");
	precacheItem("jump_bot");

	// strings
	precacheString(&"MBOT_MAPNOTSUPPORT");
	precacheString(&"MBOT_NOMORE");
	precacheString(&"MBOT_SKILLSWITCH");
	precacheString(&"MBOT_REMOVED");

	// models
	if(getCvarInt("bot_debug") == 1)
	{
		precacheModel("xmodel/prop_bear");
		precacheModel("xmodel/prop_hydrant");
		precacheModel("xmodel/prop_mortar");
		precacheModel("xmodel/furniture_toilet");
		precacheModel("xmodel/prop_wine_crate");
		precacheModel("xmodel/military_flak88_shell");
		precacheModel("xmodel/furniture_armchair");
	  
		precacheString(&"MBOTDEV_ITEM0");
		precacheString(&"MBOTDEV_ITEM1");
		precacheString(&"MBOTDEV_ITEM2");
		precacheString(&"MBOTDEV_ITEM3");
		precacheString(&"MBOTDEV_ITEM4");
		precacheString(&"MBOTDEV_ITEM5");
		precacheString(&"MBOTDEV_ITEM6");

		precacheString(&"MBOTDEV_EMPTY");
		precacheString(&"MBOTDEV_STAND");
		precacheString(&"MBOTDEV_CROUCH");
		precacheString(&"MBOTDEV_PRONE");
		precacheString(&"MBOTDEV_UP");
		precacheString(&"MBOTDEV_OVER");
		precacheString(&"MBOTDEV_W");
		precacheString(&"MBOTDEV_G");
		precacheString(&"MBOTDEV_F");
		precacheString(&"MBOTDEV_C");
		precacheString(&"MBOTDEV_J");
		precacheString(&"MBOTDEV_M");
		precacheString(&"MBOTDEV_L");
		precacheString(&"MBOTDEV_LSKOBKA");
		precacheString(&"MBOTDEV_PSKOBKA");
		precacheString(&"MBOTDEV_ZPT");
	  
		// Cepe7a -->
		precacheString(&"WP_AUTO_ON");
		precacheString(&"WP_AUTO_OFF");
		precacheString(&"WP_TYPE_W");
		precacheString(&"WP_TYPE_G");
		precacheString(&"WP_TYPE_F");
		precacheString(&"WP_TYPE_C");
		precacheString(&"WP_TYPE_J");
		precacheString(&"WP_TYPE_M");
		precacheString(&"WP_TYPE_L");
		precacheString(&"WP_CANT_CREATE");
		precacheString(&"WP_DUMPED");
		precacheString(&"WP_WRN_NO_NEXT");
		precacheString(&"WP_WRN_MORE_ONE");
		precacheString(&"WP_NO_ERRORS");
	  
		precacheString(&"MBOTDEV_START_POINT");
		precacheString(&"MBOTDEV_START_POINT_CANCELED");
		precacheString(&"MBOTDEV_END_POINT");
		precacheString(&"MBOTDEV_END_POINT_CANCELED");
		
		precacheString(&"MBOT_ADD_USAGE");
		// <-- Cepe7a
	}

	// menus
	precacheMenu("mbot_restart");	
}

//--------------------------------------------------------------------------------------------------------------------------------------
// Bot functions
//--------------------------------------------------------------------------------------------------------------------------------------
/*
--------------
 botJoin
--------------
*/
botJoin(team, weapon)
{
	
	while(!isdefined(self.pers["team"]))
		wait .05;

	self notify("menuresponse", game["menu_team"], team);
	
	wait 0.4;
	
	if(team == "autoassign")
		team = self.pers["team"];
		
	pweapon = "";

	if(team == "allies")
	{
		//level.bots_al++;
		switch(game["allies"])
		{
			case "american":
				self.smoketype = "smoke_grenade_american_mp";
				self.botsmoke = "smoke_grenade_american_bot";
				self.grenadetype = "frag_grenade_american_mp";
				self.botgrenade = "frag_grenade_american_bot";
				// Cepe7a -->
				switch (weapon)
				{
					case "1" : rnd = 0; break;
			case "2" : rnd = 1; break;
			case "3" : rnd = 2; break;
			case "4" : rnd = 3; break;
			case "5" : rnd = 4; break;
			case "6" : rnd = 5; break;
			case "7" : rnd = 6; break;
                        case "8" : rnd = 7; break;
			case "9" : rnd = 8; break;
			case "10" : rnd = 9; break;
			case "11" : rnd = 10; break;
			case "12" : rnd = 11; break;
			case "13" : rnd = 12; break;
			case "14" : rnd = 13; break;
                        case "15" : rnd = 14; break;
			case "16" : rnd = 15; break;
			case "17" : rnd = 16; break;
			case "18" : rnd = 17; break;
			case "19" : rnd = 18; break;
			case "20" : rnd = 19; break;
			case "21" : rnd = 20; break;
                        case "22" : rnd = 21; break;
                        case "23" : rnd = 22; break;
			case "24" : rnd = 23; break;
			case "25" : rnd = 24; break;
			case "26" : rnd = 25; break;
			case "27" : rnd = 26; break;
			case "28" : rnd = 27; break;
			case "29" : rnd = 28; break;
                        case "30" : rnd = 29; break;
			case "31" : rnd = 30; break;
			case "32" : rnd = 31; break;
			case "33" : rnd = 32; break;
			case "34" : rnd = 33; break;
			case "35" : rnd = 34; break;
			case "36" : rnd = 35; break;
                        case "37" : rnd = 36; break;
			case "38" : rnd = 37; break;

					default:
						rnd = randomInt(38);
					break;
				}
				// <-- Cepe7a
				
				switch(rnd)
				{
			case 0:  pweapon = "greasegun"; break;
                        case 1:  pweapon = "greasegun"; break;
                        case 2:  pweapon = "greasegun"; break;
			case 3:  pweapon = "m1carbine"; break;
                        case 4:  pweapon = "m1carbine"; break;
			case 5:  pweapon = "m1garand"; break;
                        case 6:  pweapon = "m1garand"; break;
			case 7:  pweapon = "bar"; break;
                        case 8:  pweapon = "bar"; break;
                        case 9:  pweapon = "shotgun"; break;
                        case 10:  pweapon = "thompson"; break;
                        case 11:  pweapon = "thompson"; break;
                        case 12:  pweapon = "thompson"; break;
			case 13:  pweapon = "springfield"; break;
                        case 14:  pweapon = "sten"; break;
                        case 15:  pweapon = "sten"; break;
			case 16:  pweapon = "enfield"; break;
                        case 17:  pweapon = "bren"; break;
			case 18:  pweapon = "enfield_scope"; break;
                        case 19:  pweapon = "SVT40"; break;
                        case 20:  pweapon = "SVT40"; break;
                        case 21:  pweapon = "PPS42"; break;
                        case 22:  pweapon = "PPS42"; break;
                        case 23:  pweapon = "ppsh"; break;
                        case 24:  pweapon = "ppsh"; break;
                        case 25:  pweapon = "ppsh"; break;
                        case 26:  pweapon = "g43"; break;
                        case 27:  pweapon = "g43"; break;
			case 28:  pweapon = "mosin_nagant"; break;
                        case 29:  pweapon = "mosin_nagant_sniper"; break;
                        case 30:  pweapon = "mp40"; break;
                        case 31:  pweapon = "mp40"; break;
			case 32:  pweapon = "kar98k"; break;
                        case 33:  pweapon = "kar98k"; break;
			case 34:  pweapon = "ppsh"; break;
			case 35:  pweapon = "kar98k_sniper"; break;
			case 36:  pweapon = "mp44"; break;
                        case 37:  pweapon = "mp44"; break;
                        case 38:  pweapon = "mp44"; break;
				}
			break;
			
			case "british":
				self.smoketype = "smoke_grenade_british_mp";
				self.botsmoke = "smoke_grenade_british_bot";
				self.grenadetype = "frag_grenade_british_mp";
				self.botgrenade = "frag_grenade_british_bot";
				// Cepe7a -->
				switch (weapon)
				{
					case "1" : rnd = 0; break;
			case "2" : rnd = 1; break;
			case "3" : rnd = 2; break;
			case "4" : rnd = 3; break;
			case "5" : rnd = 4; break;
			case "6" : rnd = 5; break;
			case "7" : rnd = 6; break;
                        case "8" : rnd = 7; break;
			case "9" : rnd = 8; break;
			case "10" : rnd = 9; break;
			case "11" : rnd = 10; break;
			case "12" : rnd = 11; break;
			case "13" : rnd = 12; break;
			case "14" : rnd = 13; break;
                        case "15" : rnd = 14; break;
			case "16" : rnd = 15; break;
			case "17" : rnd = 16; break;
			case "18" : rnd = 17; break;
			case "19" : rnd = 18; break;
			case "20" : rnd = 19; break;
			case "21" : rnd = 20; break;
                        case "22" : rnd = 21; break;
                        case "23" : rnd = 22; break;
			case "24" : rnd = 23; break;
			case "25" : rnd = 24; break;
			case "26" : rnd = 25; break;
			case "27" : rnd = 26; break;
			case "28" : rnd = 27; break;
			case "29" : rnd = 28; break;
                        case "30" : rnd = 29; break;
			case "31" : rnd = 30; break;
			case "32" : rnd = 31; break;
			case "33" : rnd = 32; break;
			case "34" : rnd = 33; break;
			case "35" : rnd = 34; break;
			case "36" : rnd = 35; break;
                        case "37" : rnd = 36; break;
			case "38" : rnd = 37; break;
					
						
					default:
						rnd = randomInt(38);
					break;
				}
				// <-- Cepe7a
				
				switch(rnd)
				{
					case 0:  pweapon = "greasegun"; break;
                        case 1:  pweapon = "greasegun"; break;
                        case 2:  pweapon = "greasegun"; break;
			case 3:  pweapon = "m1carbine"; break;
                        case 4:  pweapon = "m1carbine"; break;
			case 5:  pweapon = "m1garand"; break;
                        case 6:  pweapon = "m1garand"; break;
			case 7:  pweapon = "bar"; break;
                        case 8:  pweapon = "bar"; break;
                        case 9:  pweapon = "shotgun"; break;
                        case 10:  pweapon = "thompson"; break;
                        case 11:  pweapon = "thompson"; break;
                        case 12:  pweapon = "thompson"; break;
			case 13:  pweapon = "springfield"; break;
                        case 14:  pweapon = "sten"; break;
                        case 15:  pweapon = "sten"; break;
			case 16:  pweapon = "enfield"; break;
                        case 17:  pweapon = "bren"; break;
			case 18:  pweapon = "enfield_scope"; break;
                        case 19:  pweapon = "SVT40"; break;
                        case 20:  pweapon = "SVT40"; break;
                        case 21:  pweapon = "PPS42"; break;
                        case 22:  pweapon = "PPS42"; break;
                        case 23:  pweapon = "ppsh"; break;
                        case 24:  pweapon = "ppsh"; break;
                        case 25:  pweapon = "ppsh"; break;
                        case 26:  pweapon = "g43"; break;
                        case 27:  pweapon = "g43"; break;
			case 28:  pweapon = "mosin_nagant"; break;
                        case 29:  pweapon = "mosin_nagant_sniper"; break;
                        case 30:  pweapon = "mp40"; break;
                        case 31:  pweapon = "mp40"; break;
			case 32:  pweapon = "kar98k"; break;
                        case 33:  pweapon = "kar98k"; break;
			case 34:  pweapon = "ppsh"; break;
			case 35:  pweapon = "kar98k_sniper"; break;
			case 36:  pweapon = "mp44"; break;
                        case 37:  pweapon = "mp44"; break;
                        case 38:  pweapon = "mp44"; break;
				}
			break;
			
			case "russian":
				self.smoketype = "smoke_grenade_russian_mp";
				self.botsmoke = "smoke_grenade_russian_bot";
				self.grenadetype = "frag_grenade_russian_mp";
				self.botgrenade = "frag_grenade_russian_bot";
				// Cepe7a -->
				switch (weapon)
				{
					case "1" : rnd = 0; break;
			case "2" : rnd = 1; break;
			case "3" : rnd = 2; break;
			case "4" : rnd = 3; break;
			case "5" : rnd = 4; break;
			case "6" : rnd = 5; break;
			case "7" : rnd = 6; break;
                        case "8" : rnd = 7; break;
			case "9" : rnd = 8; break;
			case "10" : rnd = 9; break;
			case "11" : rnd = 10; break;
			case "12" : rnd = 11; break;
			case "13" : rnd = 12; break;
			case "14" : rnd = 13; break;
                        case "15" : rnd = 14; break;
			case "16" : rnd = 15; break;
			case "17" : rnd = 16; break;
			case "18" : rnd = 17; break;
			case "19" : rnd = 18; break;
			case "20" : rnd = 19; break;
			case "21" : rnd = 20; break;
                        case "22" : rnd = 21; break;
                        case "23" : rnd = 22; break;
			case "24" : rnd = 23; break;
			case "25" : rnd = 24; break;
			case "26" : rnd = 25; break;
			case "27" : rnd = 26; break;
			case "28" : rnd = 27; break;
			case "29" : rnd = 28; break;
                        case "30" : rnd = 29; break;
			case "31" : rnd = 30; break;
			case "32" : rnd = 31; break;
			case "33" : rnd = 32; break;
			case "34" : rnd = 33; break;
			case "35" : rnd = 34; break;
			case "36" : rnd = 35; break;
                        case "37" : rnd = 36; break;
			case "38" : rnd = 37; break;
						
					default:
						rnd = randomInt(38);
					break;
				}
				// <-- Cepe7a
				switch(rnd)
				{
					case 0:  pweapon = "greasegun"; break;
                        case 1:  pweapon = "greasegun"; break;
                        case 2:  pweapon = "greasegun"; break;
			case 3:  pweapon = "m1carbine"; break;
                        case 4:  pweapon = "m1carbine"; break;
			case 5:  pweapon = "m1garand"; break;
                        case 6:  pweapon = "m1garand"; break;
			case 7:  pweapon = "bar"; break;
                        case 8:  pweapon = "bar"; break;
                        case 9:  pweapon = "shotgun"; break;
                        case 10:  pweapon = "thompson"; break;
                        case 11:  pweapon = "thompson"; break;
                        case 12:  pweapon = "thompson"; break;
			case 13:  pweapon = "springfield"; break;
                        case 14:  pweapon = "sten"; break;
                        case 15:  pweapon = "sten"; break;
			case 16:  pweapon = "enfield"; break;
                        case 17:  pweapon = "bren"; break;
			case 18:  pweapon = "enfield_scope"; break;
                        case 19:  pweapon = "SVT40"; break;
                        case 20:  pweapon = "SVT40"; break;
                        case 21:  pweapon = "PPS42"; break;
                        case 22:  pweapon = "PPS42"; break;
                        case 23:  pweapon = "ppsh"; break;
                        case 24:  pweapon = "ppsh"; break;
                        case 25:  pweapon = "ppsh"; break;
                        case 26:  pweapon = "g43"; break;
                        case 27:  pweapon = "g43"; break;
			case 28:  pweapon = "mosin_nagant"; break;
                        case 29:  pweapon = "mosin_nagant_sniper"; break;
                        case 30:  pweapon = "mp40"; break;
                        case 31:  pweapon = "mp40"; break;
			case 32:  pweapon = "kar98k"; break;
                        case 33:  pweapon = "kar98k"; break;
			case 34:  pweapon = "ppsh"; break;
			case 35:  pweapon = "kar98k_sniper"; break;
			case 36:  pweapon = "mp44"; break;
                        case 37:  pweapon = "mp44"; break;
                        case 38:  pweapon = "mp44"; break;
				}
			break;
		}

		self.pweapon = pweapon; // Cepe7a
		self notify("menuresponse", game["menu_weapon_allies"], pweapon+"_mp"); // Cepe7a
	}
	else if(team == "axis")
	{
		//level.bots_ax++;
		rnd = randomInt(5);

		self.smoketype = "smoke_grenade_german_mp";
		self.botsmoke = "smoke_grenade_german_bot";
		self.grenadetype = "frag_grenade_german_mp";
		self.botgrenade = "frag_grenade_german_bot";
		// Cepe7a -->
		switch (weapon)
		{
			case "1" : rnd = 0; break;
			case "2" : rnd = 1; break;
			case "3" : rnd = 2; break;
			case "4" : rnd = 3; break;
			case "5" : rnd = 4; break;
			case "6" : rnd = 5; break;
			case "7" : rnd = 6; break;
                        case "8" : rnd = 7; break;
			case "9" : rnd = 8; break;
			case "10" : rnd = 9; break;
			case "11" : rnd = 10; break;
			case "12" : rnd = 11; break;
			case "13" : rnd = 12; break;
			case "14" : rnd = 13; break;
                        case "15" : rnd = 14; break;
			case "16" : rnd = 15; break;
			case "17" : rnd = 16; break;
			case "18" : rnd = 17; break;
			case "19" : rnd = 18; break;
			case "20" : rnd = 19; break;
			case "21" : rnd = 20; break;
                        case "22" : rnd = 21; break;
                        case "23" : rnd = 22; break;
			case "24" : rnd = 23; break;
			case "25" : rnd = 24; break;
			case "26" : rnd = 25; break;
			case "27" : rnd = 26; break;
			case "28" : rnd = 27; break;
			case "29" : rnd = 28; break;
                        case "30" : rnd = 29; break;
			case "31" : rnd = 30; break;
			case "32" : rnd = 31; break;
			case "33" : rnd = 32; break;
			case "34" : rnd = 33; break;
			case "35" : rnd = 34; break;
			case "36" : rnd = 35; break;
                        case "37" : rnd = 36; break;
			case "38" : rnd = 37; break;
			
						
			default:
				rnd = randomInt(38);
			break;
		}
				// <-- Cepe7a
		switch(rnd)
		{
			case 0:  pweapon = "greasegun"; break;
                        case 1:  pweapon = "greasegun"; break;
                        case 2:  pweapon = "greasegun"; break;
			case 3:  pweapon = "m1carbine"; break;
                        case 4:  pweapon = "m1carbine"; break;
			case 5:  pweapon = "m1garand"; break;
                        case 6:  pweapon = "m1garand"; break;
			case 7:  pweapon = "bar"; break;
                        case 8:  pweapon = "bar"; break;
                        case 9:  pweapon = "shotgun"; break;
                        case 10:  pweapon = "thompson"; break;
                        case 11:  pweapon = "thompson"; break;
                        case 12:  pweapon = "thompson"; break;
			case 13:  pweapon = "springfield"; break;
                        case 14:  pweapon = "sten"; break;
                        case 15:  pweapon = "sten"; break;
			case 16:  pweapon = "enfield"; break;
                        case 17:  pweapon = "bren"; break;
			case 18:  pweapon = "enfield_scope"; break;
                        case 19:  pweapon = "SVT40"; break;
                        case 20:  pweapon = "SVT40"; break;
                        case 21:  pweapon = "PPS42"; break;
                        case 22:  pweapon = "PPS42"; break;
                        case 23:  pweapon = "ppsh"; break;
                        case 24:  pweapon = "ppsh"; break;
                        case 25:  pweapon = "ppsh"; break;
                        case 26:  pweapon = "g43"; break;
                        case 27:  pweapon = "g43"; break;
			case 28:  pweapon = "mosin_nagant"; break;
                        case 29:  pweapon = "mosin_nagant_sniper"; break;
                        case 30:  pweapon = "mp40"; break;
                        case 31:  pweapon = "mp40"; break;
			case 32:  pweapon = "kar98k"; break;
                        case 33:  pweapon = "kar98k"; break;
			case 34:  pweapon = "ppsh"; break;
			case 35:  pweapon = "kar98k_sniper"; break;
			case 36:  pweapon = "mp44"; break;
                        case 37:  pweapon = "mp44"; break;
                        case 38:  pweapon = "mp44"; break;
		}
    
		self.pweapon = pweapon; // Cepe7a
		self notify("menuresponse", game["menu_weapon_axis"], pweapon+"_mp"); // Cepe7a
	}		
	
	// Cepe7a -->
	//        
	players = getentarray("player", "classname");
	allies = "";
	axis = "";
	for(i=0; i<players.size; i++)
	{
		player = players[i];
		if (isDefined(player.isbot) && player.pers["team"] != "spectator")
		{
			num = weaponToNumber(player.pers["team"], player.pweapon);
			if (player.pers["team"] == "allies")
				allies += num + " ";
			else
				axis += num + " ";
		}
	}
	setcvar("_bots_allies", allies);
	setcvar("_bots_axis", axis);
	self notify("bot_joined");
	// <-- Cepe7a
}


// Cepe7a -->
weaponToNumber(team, weapon)
{
	num = 0;
	if(team == "allies")
	{
		switch(game["allies"])
		{
			case "american":
				switch (weapon)
				{
					case "greasegun"	: num = 1; break;
					case "m1carbine"	: num = 2; break;
					case "m1garand"		: num = 3; break;
					case "springfield"	: num = 4; break;
         			case "shotgun"		: num = 5; break;
					case "thompson"		: num = 6; break;
					case "bar"			: num = 7; break;
				}
			break;
			
			case "british":
				switch (weapon)
				{
					case "sten"			: num = 1; break;
					case "enfield"		: num = 2; break;
					case "m1garand"		: num = 3; break;
					case "enfield_scope": num = 4; break;
	         		case "shotgun"		: num = 5; break;
					case "thompson"		: num = 6; break;
					case "bren"			: num = 7; break;
				}
			break;
			
			case "russian":
				switch (weapon)
				{
					case "pps42"				: num = 1; break;
					case "mosin_nagant"			: num = 2; break;
					case "svt40"				: num = 3; break;
					case "mosin_nagant_sniper"	: num = 4; break;
         			case "shotgun"				: num = 5; break;
					case "ppsh"					: num = 6; break;
				}
			break;
		}
	}
	else if(team == "axis")
	{
		switch (weapon)
		{
			case "mp40"			: num = 1; break;
			case "kar98k"		: num = 2; break;
			case "g43"			: num = 3; break;
			case "kar98k_sniper": num = 4; break;
			case "shotgun"		: num = 5; break;
			case "mp44"			: num = 6; break;
		}
	}
	return num;
}
// <-- Cepe7a


/*
--------------
 checkBotCollision
--------------
*/
checkBotCollision()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		dist = distance(self.origin, player.origin);
    
		if(player == self || !isalive(player) || dist > 96)
			continue;

			if(dist < 32) //         
			{
				return false;
				/*if(randomInt(2))
					return true;
				else
					return false;*/
			}
			
		else if (dist < 64)
		{
			
			
			if(isdefined(player.next) && self.next.origin == player.next.origin && closer(self.next.origin, player.origin, self.origin))
			{
				/*if (isdefined(player.alert) && player.alert && isDefined(player.enemy))
				{
					//self StopRotate();
					DoRotateOrg(player.enemy.origin, 0.1);
				}*/
				return true;
			}

			if (self.next.next.size)
			{
				next = level.wp[self.next.next[0]];
				if (isDefined(player.next) && next.origin == player.next.origin)
					return true;
			}
			
		
			//if (isDefined(player.next) && player.next.origin != self.next.origin)
				//return false;

		}
	}
  
	return false;
}

/*
--------------
 checkPlayerCollision
--------------
*/
checkPlayerCollision()
{
  if(isalive(level.plr))
  {
    if(distance(self.origin, level.plr.origin) < 50)
    {
      vec1 = vectorNormalize(self.next.origin - self.origin);         //   
      vec2 = vectorNormalize(level.plr.origin - self.origin);         //  
      dot = vectordot(vec1, vec2);

      if(dot > .5)
        return true;
    }
  }
  
  return false;
}

/*
--------------
 addBotWeapon
--------------
*/
addBotWeapon(weapon, ammo, clipammo)
{
  if(isdefined(self.pers["weapon"]))
  {
    self takeweapon(self.pers["weapon"]);
    self.pers["weapon"] = weapon;
	  self giveweapon(weapon);
    self setweaponslotammo("primary", ammo);
	  self setweaponslotclipammo("primary", clipammo);
    self setspawnweapon(weapon);   //     
	  self switchtoweapon(weapon);   //    ?
	  self switchToWeapon(self.pers["weapon"]);
	}

}

/*
--------------
 getBotWeaponBasedGrenadeCount
--------------
*/
getBotWeaponBasedGrenadeCount(weapon)
{
  switch(weapon)
	{
	case "springfield_bot_st":
	case "enfield_scope_bot_st":
	case "mosin_nagant_sniper_bot_st":
	case "kar98k_sniper_bot_st":
	case "enfield_bot_st":
	case "mosin_nagant_bot_st":
	case "kar98k_bot_st":
		return 3;

	case "m1carbine_bot_st":
	case "m1garand_bot_st":
	case "SVT40_bot_st":
	case "g43_bot_st":
	case "bar_bot_st":
	case "bren_bot_st":
	case "mp44_bot_st":
		return 2;
		
	default:
	case "thompson_bot_st":
	case "sten_bot_st":
	case "ppsh_bot_st":
	case "mp40_bot_st":
	case "PPS42_bot_st":
	case "shotgun_bot_st":
	case "greasegun_bot_st":
		return 1;
	}
}

/*
--------------
 getBotWeaponBasedSmokeGrenadeCount
--------------
*/
getBotWeaponBasedSmokeGrenadeCount(weapon)
{
	switch(weapon)
	{
	case "thompson_bot_st":
	case "sten_bot_st":
	case "ppsh_bot_st":
	case "mp40_bot_st":
	case "PPS42_bot_st":
	case "shotgun_bot_st":
	case "greasegun_bot_st":
		return 1;

  case "m1carbine_bot_st":
	case "m1garand_bot_st":
	case "enfield_bot_st":
	case "mosin_nagant_bot_st":
	case "SVT40_bot_st":
	case "kar98k_bot_st":
	case "g43_bot_st":
	case "bar_bot_st":
	case "bren_bot_st":
	case "mp44_bot_st":
	case "springfield_bot_st":
	case "enfield_scope_bot_st":
	case "mosin_nagant_sniper_bot_st":
	case "kar98k_sniper_bot_st":
	default:
		return 0;
	}
}

/*
--------------
 giveBotGrenades
--------------
*/
giveBotGrenades()
{
  self.botgrenadecount = getBotWeaponBasedGrenadeCount(self.pers["weapon"]);
  self.botsmokecount = getBotWeaponBasedSmokeGrenadeCount(self.pers["weapon"]);
  self setWeaponClipAmmo(self.grenadetype, self.botgrenadecount);
  if(self.botsmokecount)
    self setWeaponClipAmmo(self.smoketype, self.botsmokecount);
  else
    self takeWeapon(self.smoketype);
}


/*
--------------
 goToNode
--------------
*/
goToNode(nodeOrg)
{
	self endon("killed_player");
	self endon("stopmove");
	//self.botorg endon("movedone");
  
	if(nodeOrg == self.botorg.origin || isDefined(self.skipmove))
	{
		self.skipmove = undefined;
		self.state = "idle";
		return;
	}
  
	dist = distance(self.botorg.origin, nodeOrg); // Cepe7a
	moveTime = dist/level.movespeed;
	target = vectorNormalize(nodeOrg - self.origin);
	angles = vectorToAngles(target);
  
	// Cepe7a -->
	//self setplayerangles(angles);
	self StopRotate();
	self thread DoRotateOrg(nodeOrg, randomFloat(2-(level.botskill*0.2))+0.1); 
	// <-- Cepe7a

	self thread mbot_playLoopSound("step_bot_run", .43);
  
	self.botorg moveto(nodeOrg, moveTime, 0, 0);
	
	while (1)
	{
		if (distance(self.origin, nodeOrg) < 32)
		{
			self.state = "idle";
			return;
		}
		wait 0.1;
	}
}

/*
--------------
 stopMoving
--------------
*/
stopMoving()

{
	
	// Cepe7a -->
	self endon("killed_player");
	self notify("stopmove");
	self.skiprotate = undefined;
	self StopRotate(); 
	// <-- Cepe7a

	self mbot_stopLoopSound();
	self.botorg moveto((self.origin + (1, 1, 0)), 0.01, 0, 0);

}

/*
--------------
 throwGrenade
--------------
*/
throwGrenade()
{
	self endon("killed_player");

	if(self.botgrenadecount > 0)
	{
		weapon = self.pers["weapon"];
	
		// Cepe7a -->
		//self setplayerangles(self.next.angles);
                self.botorg playsound("generic_meleecharge_american_1"); //ASDFG
           //     self.botorg playsound("weap_rusgrenade_fire_plr"); //ASDFG
                self.botorg playsound("generic_meleeattack_american_1"); //ASDFG

		self.skiprotate = undefined;
		self StopRotate();
		self DoRotateAng(self.next.angles, 1-(level.botskill*0.1)+0.1);
		// <-- Cepe7a
		
		self addBotWeapon(self.botgrenade, 9999, 3);

		for(i = 0; i < 3; i++)             //   
		{
			self freezecontrols(false);
			wait .3;
		}

		
		self freezecontrols(true);
		self.botgrenadecount--;
		self addBotWeapon(weapon, 9999, self.pclipammo);
		self setWeaponClipAmmo(self.grenadetype, self.botgrenadecount);
	}
	self.state = "done";
}


/*
--------------
 fallGravity
--------------
*/
fallGravity()
{
	self endon("killed_player");
	
	if(isdefined(self.next.next[0]))
	{
		destOrg = level.wp[self.next.next[0]].origin;

		ang = vectorToAngles((vectorNormalize(destOrg - self.next.origin)));
		vel = anglesToForward((0.0, ang[1], 0.0));
		
		// Cepe7a -->
		dst = distance((self.next.origin[0], self.next.origin[1], 0), (destOrg[0], destOrg[1], 0));
		height = self.next.origin[2] - destOrg[2];
		sqr = getvelsqr(height);
		dst = (dst) / sqr;
		
		if (dst > 240)
			dst = 240;
		vel = (vel[0]*dst, vel[1]*dst, 0);
		
		//self setplayerangles((30.0, ang[1], 0.0));
		self StopRotate();
		self thread DoRotateAng((30.0, ang[1], 0.0), 0.1);
		// <-- Cepe7a
			
		weapon = undefined;
		weaponModel = undefined;
		if(height > 64)
		{
			weapon = self.pers["weapon"];
			weaponModel = getWeaponModel(weapon);
			self attach(weaponModel, "tag_weapon_right");
			self addBotWeapon("jump_bot", 0, 0);
		}

		self.botorg movegravity(vel, sqr);
		self.botorg waittill("movedone");
		
		self thread playSurface("Land_"); // Cepe7a
		
		if(height > 64)
		{
			self addBotWeapon(weapon, 9999, self.pclipammo);
			self detach(weaponModel, "tag_weapon_right");
		}
		
		self.botorg moveto(destOrg, 0.01, 0, 0);
		self.botorg waittill("movedone");
		
	}

	self.state = "done";
}
    
/*
--------------
 jumpGravity
--------------
*/
jumpGravity()
{
	self endon("killed_player");
	
	if(isdefined(self.next.next[0]))
	{
		destOrg = level.wp[self.next.next[0]].origin;

		// Cepe7a -->
		vmax = 240;
		ang = vectorToAngles((vectorNormalize(destOrg - self.next.origin)));
		ang = (0, ang[1], 0);
		vel = anglesToForward(ang);
		vel = (vel[0], vel[1], 1);
		
		
		dst = distance(destOrg, self.next.origin);
		if (destOrg[2] >= self.next.origin[2])
		{
			dst = dst * 1.6;
			if (dst > vmax)
				dst = vmax;
			vel = (dst*vel[0], dst*vel[1], vmax);
		} 
		else
		{
			h = self.next.origin[2] - destOrg[2];
			dst = dst*1.6 - h*(1.25+h/(vmax*10));
			if (dst > vmax)
				dst = vmax;
			vel = (dst*vel[0], dst*vel[1], vmax);
		}
		

		//self setplayerangles(ang);
		self.skiprotate = undefined;
		self StopRotate();
		self thread DoRotateAng(ang, 0.5);
		// <-- Cepe7a
    
		weapon = self.pers["weapon"];
		weaponModel = getWeaponModel(weapon);
		self attach(weaponModel, "tag_weapon_right");
		self addBotWeapon("jump_bot", 0, 0);
    
		self.botorg movegravity(vel, 10);
		
		// Cepe7a -->		
		if (destOrg[2] >= self.next.origin[2])
		{
			//  
			wait 0.5;
			while(self.botorg.origin[2] > destOrg[2])
			{
				wait .01;
			}
		}
		else
		{
			//  
			wait 0.5;
			while(self.botorg.origin[2] > destOrg[2]+32 )
			{
				wait .01;
			}
		}
		// <-- Cepe7a

		
		self thread playSurface("Land_"); // Cepe7a
                self thread playSurface("US_bra_inform_suppressed_generic");//ASDFG
		
		self.botorg moveto(destOrg, 0.1, 0, 0);
		self.botorg waittill("movedone");
		
		//self.botorg playsound("bot_land");
    
		self addBotWeapon(weapon, 9999, self.pclipammo);
		self detach(weaponModel, "tag_weapon_right");
	}

	self.state = "done";
}

/*
--------------
 doMantle
--------------
*/
doMantle()
{
  self endon("killed_player");
  
  if(isdefined(self.next.next[0]))
  {
	// Cepe7a -->
	self.skiprotate = undefined;
	self StopRotate();
	wait 0.1;
	// <-- Cepe7a
	
    next = level.wp[self.next.next[0]];
    dist = distance(self.next.origin, next.origin);
    
    ang = vectorToAngles((vectorNormalize(next.origin - self.next.origin)));
  
    vec = anglesToForward((-80.0, ang[1], 0.0));
    vec = maps\mp\_utility::vectorScale(vec, dist);
    destOrg = self.next.origin + vec;
  
    self setplayerangles((20, ang[1], 0));

    weapon = self.pers["weapon"];
    self addBotWeapon("mantle_up_bot", 0, 0);
    
    //self.botorg playSound("bot_raise_weap");
   // self.botorg playSound("US_rnd_inform_suppressed");
    
    wait .25;

    moveTime = distance(self.next.origin, destOrg)/100;
    self.botorg moveto(destOrg, moveTime, 0, 0);
    self.botorg waittill("movedone");
    
    if(self.next.mode == 1 && isdefined(next.next[0])) //  mantle_over
    {
      self.next = next;
      
      vec = anglesToForward((10, ang[1], 0));
      vec = maps\mp\_utility::vectorScale(vec, 32);
      destOrg = self.next.origin + vec;
      moveTime = distance(self.botorg.origin, destOrg)/100;
      
      // 
      self addBotWeapon("mantle_over_bot", 0, 0);
      
      wait .1;

      self.botorg moveto(destOrg, moveTime, 0, 0);
      self.botorg waittill("movedone");
      
      //   
      self addBotWeapon(weapon, 9999, self.pclipammo);
      self.state = "fall";
      
      destOrg = level.wp[self.next.next[0]].origin + (0, 0, 20);
      self.botorg movegravity((0.0, 0.0, 0.0), 10);
      while(self.botorg.origin[2] > destOrg[2])
        wait .01;

      self.botorg moveto((destOrg - (0, 0, 20)), .075, 0, 0);  // movez  
      self.botorg playsound("bot_land");
      self.botorg waittill("movedone");
    }
    else
    {
      self addBotWeapon(weapon, 9999, self.pclipammo);
    }
  }
  
  self.state = "done";
}

/*
--------------
 climbUp
--------------
*/
climbUp()
{
  self endon("killed_player");

  if(isdefined(self.next.next[0]))
  {
    next = level.wp[self.next.next[0]];
    
    height = next.origin[2] - self.next.origin[2] - 10;
    if(height < 10)
    {
      self.state = "done";
      return;
    }

    destOrg = self.next.origin + (0.0, 0.0, height);
    moveTime = distance(self.next.origin, destOrg)/100;

	// Cepe7a -->
	self.skiprotate = undefined;
	self StopRotate();
	wait 0.1;
	// <-- Cepe7a
	
    ang = vectorToAngles((vectorNormalize(next.origin - self.next.origin)));
    self setplayerangles((-50, ang[1], 0));
    
    self.botorg playSound("bot_raise_weap");
    weapon = self.pers["weapon"];
    self addBotWeapon("climb_up_bot", 0, 0);
    
    self thread mbot_playLoopSound("step_bot_climb", .4);
   // self thread mbot_playLoopSound("Lad", .4);
    // self.botorg playSound("generic_pain_american_2"); //ASDFG
    
    self.botorg moveto(destOrg, moveTime, 0, 0);
    self.botorg waittill("movedone");
    
    self mbot_stopLoopSound();
    
    self addBotWeapon(weapon, 9999, self.pclipammo);
  }
  
  self.state = "done";
}

/*
--------------
 makeCamp
--------------
*/
makeCamp(time)
{
	self endon("killed_player");
  
	if(isdefined(self.next.angles))
	{
		// Cepe7a -->
		//self setplayerangles(self.next.angles);
		self StopRotate();
		self DoRotateAng(self.next.angles, 0);
		// <-- Cepe7a
	}

	self.pclipammo = self getweaponslotclipammo("primary");
	self setweaponslotammo("primary", 0);
	self setweaponslotclipammo("primary", 0);
  
	self freezecontrols(false);
	
	// Cepe7a -->
	n = int(time / 0);
	for (i=0; i<n; i++)
	{
		wait 0.001;
		if (isDefined(self.gotostart))
			break;
	}
	//wait time;
	// <-- Cepe7a
	
  
	if(!self.alert)
	{
		self freezecontrols(true);
		self givemaxammo(self.pers["weapon"]);
		self setweaponslotclipammo("primary", self.pclipammo);
  
		wait 0;      //     
	}
  
	self.state = "done";
}

/*
--------------
 getNextNode
--------------
*/
getNextNode()
{
  next = undefined;
  
	// Cepe7a -->
	self.skipmove = undefined;
	if (isDefined(self.gotostart) && isDefined(level.startwp))
	{
		next = level.wp[level.startwp];
		self.gotostart = undefined;
		self.skipmove = true;
		self.botorg moveto(next.origin, 0.01, 0, 0);
		self.botorg waittill("movedone");
		return next;
	}
	if (isdefined(level.startwp) && (!isdefined(self.next) || (isdefined(level.endwp) && self.next == level.wp[level.endwp] && self.next != level.wp[level.startwp])))
	{
		next = level.wp[level.startwp];
		self.skipmove = true;
		self.botorg moveto(next.origin, 0.01, 0, 0);
		self.botorg waittill("movedone");
		return next;
	}
	// <-- Cepe7a
			
	if(isdefined(self.next) && self.next.next.size != 0)
	{
		n = randomInt(self.next.next.size);
		next = level.wp[self.next.next[n]];
	}
	else
	{
		// Cepe7a -->
		if (isdefined(level.startwp) && self.next != level.wp[level.startwp])
		{
			next = level.wp[level.startwp];
			self.skipmove = true;
			self.botorg moveto(next.origin, 0.01, 0, 0);
			self.botorg waittill("movedone");
			return next;
		}
		// <-- Cepe7a
		
		next = self findStartNode();
	}
  
	return next;
}


/*
--------------
 findStartNode
--------------
*/
findStartNode()
{
	if(isdefined(level.spawnpoints))   //  32      ,        
	{
		for(i = 0; i < level.spawnpoints.size; i++)
		{
			if(distance(self.origin, level.spawnpoints[i].origin) < 16)
				return level.wp[i];
			wait 0.0001;
		}
	}

	// Cepe7a -->
	next = undefined;
	for (;;)
	{
		next = level.wp[randomInt(level.spawnpoints.size)];
		if (!isDefined(self.next) || self.next != next)
			break;
	}
		
	return next;
	// <-- Cepe7a
}

/*
--------------
 mbot_playLoopSound
--------------
*/
mbot_playLoopSound(alias, interval)
{
	self endon("stoploopsound");
  
	if(!isdefined(self.isPlayingLoopSound) || !self.isPlayingLoopSound)
	{
		self.isPlayingLoopSound = true;
    
		if (alias == "step_bot_run") 
		{
			while(isdefined(self.botorg))
			{
				self thread playSurface("step_walk_");
				wait interval;	  
			}
		}
		else
		{
			while(isdefined(self.botorg))
			{
				self.botorg playSound(alias);
				wait interval;	  
			}
		}
	}
}

/*
--------------
 mbot_stopLoopSound
--------------
*/
mbot_stopLoopSound()
{
  self.isPlayingLoopSound = false;
  self notify("stoploopsound");
}


// Cepe7a -->
addMark(tagname)
{
	i = self.mark.size;
	self.mark[i] = spawn("script_origin", (0, 0, 0));
	self.mark[i] linkto(self, tagname, (0, 0, 0), (0, 0, 0));
}


markTarget() 
{
	
	if(!isdefined(self))
		return;
		
	wait 0.1;

	self.mark = [];

	self addMark("j_spine1"); 			// 0 
	self addMark("tag_eye");  			// 1  - Must be 2nd!
	self addMark("j_elbow_bulge_le"); 	// 2  
	self addMark("j_elbow_bulge_ri"); 	// 3  
	self addMark("j_shoulder_le");		// 4 
	self addMark("j_shoulder_ri");		// 5 
	self addMark("j_hip_le");			// 6  
	self addMark("j_hip_ri");			// 7  
	self addMark("j_ankle_le");		    // 8  
	self addMark("j_ankle_ri");			// 9  
	
	wait 0.1;

	self notify("marked");
	

}
// <-- Cepe7a

endMap()
{
	map = getCvar("mapname");
	type = getCvar("g_gametype");

	if(maps\mp\mbot\_mbot::mapIsSupportBots(map, type))
		maps\mp\mbot\_mbot::loadMap(map, type);
	else
		map_restart(true);
}

PlayerKilled(sMeansOfDeath)
{
//  self maps\mp\gametypes\_weapons::dropWeapon();
	self maps\mp\gametypes\_weapons::dropOffhand();

	self.skiprotate = undefined; // Cepe7a
	
	if(isdefined(self.mark)) {
		for(i = 0; i < self.mark.size; i++) 
		{
			self.mark[i] unlink();
			self.mark[i] delete();
		}
		self.mark = undefined;
	}
}

spawnPlayer()
{
	
	self markTarget();


	
	if (isDefined(self.isbot)) // Cepe7a
	{
		self notify("bot_spawned");
		self notify("test", 1, 2, 3);
               
                
	}
		
}

playSurface(alias)
{
	trace=bulletTrace(self.origin, self.origin-(0,0,512), false, self); 
	//iprintln(trace["surfacetype"]); // *** TEMP
	if (trace["surfacetype"] == "none")
		self playsound(alias+"default");
	else
		self playsound(alias+trace["surfacetype"]);
}

// Cepe7a -->
/*
--------------
 DoRotateOrg
--------------
*/
DoRotateOrg(target, roundsec)
{
	self endon("stoprotate");
	self endon("killed_player");
	
	if (isDefined(self.skiprotate))
		return;
		
	newangles = vectorToAngles(vectorNormalize(target - self.origin));
	self thread DoRotateAng(newangles, roundsec);
}


/*
--------------
 DoRotateAng
--------------
*/
DoRotateAng(newangles, roundsec)
{
	// roundsec -     (.)
	
	self endon("stoprotate");
	self endon("killed_player");
	
	if (isDefined(self.skiprotate))
		return;
	
	
	
	iter = 20; // -     (360 )
	
	iterinc = 360/iter;
	iterwait = roundsec/iter;
	
	angles = vectorToAngles(anglestoforward(self getplayerangles()));
	newangles = vectorToAngles(anglestoforward(newangles));
	
	yaw = angleSubtract(newangles[1], angles[1]);
	pitch = angleSubtract(newangles[0], angles[0]);
	
	if (yaw < 0)
		dyaw = iterinc * (-1);
	else
		dyaw = iterinc;
	
	if (pitch < 0)
		dpitch = iterinc * (-1);
	else
		dpitch = iterinc;
		
	iyaw = abs(yaw) / iterinc;
	ipitch = abs(pitch) / iterinc;
	
	
	while (1)
	{
		if (iyaw > 1)
			angles = anglesAdd(angles, (0, dyaw, 0));
		if (ipitch > 1)
			angles = anglesAdd(angles, (dpitch, 0, 0));
			
		self setplayerangles(angles);
	
		if (iyaw > 1)
			iyaw -= 1;
		if (ipitch > 1)
			ipitch -= 1;
			
		if (iyaw <= 1 && ipitch <= 1)
			break;
		wait iterwait;
	}
	self setplayerangles(newangles);
	self notify("endrotate");
}


/*
--------------
 StopRotate
--------------
*/
StopRotate()
{
	if (isDefined(self.skiprotate))
		return;
	self notify("stoprotate"); 
	wait 0.01;
}


BlockRotate(time)
{
	self notify("stopblockrotate");
	self endon("stopblockrotate");
	self endon("killed_player");
	
	self.skiprotate = true;
	wait time;
	self.skiprotate = undefined;	
}

/*
--------------
 PlayerDamage
--------------
*/
PlayerDamage(eAttacker, iDamage,sMeansOfDeath)
{
	self endon("killed_player");
	
	if (!isDefined(self.isbot) || !isPlayer(eAttacker) || self == eAttacker)
		return;
		
	//iprintln(sMeansOfDeath); // *** TEMP
		
	if (!isDefined(self.state) || self.state == "mantle" || self.state == "climb")
		return;
		
	if (isDefined(self.alert) && !self.alert)
	{		
		self notify("stoprotate");
		self notify("endrotate");
		wait 0.01;
	
		self thread DoRotateOrg(eAttacker.origin, randomFloat(1-(level.botskill*0.1))+0.1);
		self thread BlockRotate(1);
	}
}
// <-- Cepe7a

addlotdaxis() //<Master|dEvis>
{
bot = undefined;
if(!isdefined(bot))
	bot = addtestclient();
        

		if(isdefined(bot))
		{
		pweapon = "";
		bot.isbot = true;
		bot thread botJoin("axis", pweapon); 
		}
		if(isdefined(level.botstart))
		{
			bot thread [[level.botstart]]();
		}	
}

addlotdallies() //<Master|dEvis>
{
bot = undefined;
if(!isdefined(bot))
	bot = addtestclient();

		if(isdefined(bot))
		{
		pweapon = "";
		bot.isbot = true;
		bot thread botJoin("allies", pweapon); 
		}
		if(isdefined(level.botstart))
		{
			bot thread [[level.botstart]]();
		}	
}